#define MAXCHAR 1000            /* Maximum array size */
#define MAXPTS  3000            /* Maximum no of points */
#define MAXTYPE 100             /* Maximum no of line/marker types  */
#define MAXKEY  23              /* maximum no of keywords */

#define YES     1
#define NO      0
#define ON      1
#define OFF     0
#define TRUE    1
#define FALSE   0

#define esc '\033'              /* ESC character (ascii) */
#define PSFILE "dataplot.ps"    /* postscript file */

typedef struct node_strct { 
   double x;
   double y;
   double z;
   struct node_strct *next;
   struct node_strct *prev;
} node;                          /* structure containing xyz data points */

typedef struct segm_strct { 
   struct node_strct *head;      /* pointer to first node */
   struct node_strct *tail;      /* pointer to last node */
   struct segm_strct *next;
   struct segm_strct *prev;
} segm;                          /* a single line */

typedef struct node_strct *nodeptr;
typedef struct segm_strct *segmptr;
segmptr segmhead;                /* pointer to first segment */
segmptr segmtail;                /* pointer to last segment */

/* This linked list stores the names of all the plotfiles */
typedef struct pfile_strct {
   char   plotfile[MAXCHAR];
   struct pfile_strct *prev;
   struct pfile_strct *next;
} pfile;

typedef struct pfile_strct *pfileptr;
pfileptr pfilehead;
pfileptr pfiletail;

char *term;                      /* terminal type */
char xlabel[MAXCHAR];            /* x-label */
char ylabel[MAXCHAR];            /* y-label */
char toplabel[MAXCHAR];          /* top label */
char template[MAXCHAR];          /* file with plot and marker defns */
char printer[MAXCHAR];           /* printer type */

/* plotting options */
int    grid,equalscale,postscript,printplot,noplot,xlog,ylog,clip;
int    xticks,yticks,sleeptime,landscape;
int    line,linechange,marker,markerchange;
int    autorange;
int    linetype[MAXTYPE], markertype[MAXTYPE], plottypes;
char   linelabel[MAXTYPE][MAXCHAR];
double scale;

/* boundaries */
double xmin, ymin, xmax, ymax;
