/***    parser.c - parses the input data   ***/

#include <stdio.h>
#include <strings.h>
#include <math.h>
#include "header.h"

/* Parser */
parse(op)
FILE *op;
{
   char *strcpy();
   int  len,match,i;
   char line[MAXCHAR];
   char name[MAXCHAR],value[MAXCHAR];
   char word[100][MAXCHAR];
   char *keywords[MAXKEY];

   initkeywords(keywords);

   while (len=getline(op,line, MAXCHAR) > 0)
      if (getwords(line,len,word) >= 2) {
         strcpy(name, word[0]);
         strcpy(value,word[1]);
         match = NO;
         i = 0;
         while (i < MAXKEY && match==NO ) {
            if (strcmp(keywords[i],name) == 0) {
               match = YES;
               assignvalue(i,value);
            }
            i++;
         }
         if (match==NO) fprintf(stderr,"%s: Unknown keyword\n",name);
      }
}

/* Initialize the keywords */
initkeywords(keywords) 
char *keywords[];
{
   keywords[0] = "xlabel";
   keywords[1] = "ylabel";
   keywords[2] = "toplabel";
   keywords[3] = "grid";
   keywords[4] = "equalscale";
   keywords[5] = "postscript";
   keywords[6] = "printplot";
   keywords[7] = "line";
   keywords[8] = "linechange";
   keywords[9] = "marker";
   keywords[10]= "markerchange";
   keywords[11]= "scale";
   keywords[12]= "xticks";
   keywords[13]= "yticks";
   keywords[14]= "sleeptime";
   keywords[15]= "templatefile";
   keywords[16]= "xlog";
   keywords[17]= "ylog";
   keywords[18]= "landscape";
   keywords[19]= "clip";
   keywords[20]= "printer";
   keywords[21]= "noplot";
}

assignvalue(index,value)  /* Assign a value to a keyword */
int index;
char *value;
{
   FILE   *fopen(), *ftp;
   char   *strcpy();
   char   *sprintf();
   extern char xlabel[MAXCHAR];
   extern char ylabel[MAXCHAR];
   extern char toplabel[MAXCHAR];
   extern char template[MAXCHAR];
   extern char printer[MAXCHAR];
   extern int  grid,equalscale,postscript,printplot,noplot;
   extern int  line,linechange,marker,markerchange;
   extern int  linetype[MAXTYPE], markertype[MAXTYPE],plottypes;
   extern int  xticks,yticks,sleeptime;
   extern int  xlog, ylog, clip;
   extern int  autorange;
   extern double scale;

   double atof();

   switch (index) {
   case 0 : strcpy(xlabel , value); 
            fprintf(stdout,"   Options : Xlabel          = %s\n",xlabel);
            break;
   case 1 : strcpy(ylabel , value);
            fprintf(stdout,"   Options : Ylabel          = %s\n",ylabel);
            break;
   case 2 : strcpy(toplabel , value); 
            fprintf(stdout,"   Options : Top label       = %s\n",toplabel);
            break;
   case 3 : if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               grid = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  grid = OFF;
               fprintf(stdout,"   Options : grid            = %s\n",value);
            } else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 4 : if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               equalscale = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  equalscale = OFF;
               fprintf(stdout,"   Options : equalscale      = %s\n",value);
            } else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 5 : if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               postscript = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  postscript = OFF;
               fprintf(stdout,"   Options : postscript      = %s\n",value);
            } else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 6 : if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               printplot  = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  printplot  = OFF;
               fprintf(stdout,"   Options : printplot       = %s\n",value);
            } else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 7 : if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               line = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  line = OFF;
               fprintf(stdout,"   Options : line            = %s\n",value);
               if (line == OFF) marker = ON;
            } else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 8 : if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               linechange = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  linechange = OFF;
               fprintf(stdout,"   Options : linechange      = %s\n",value);
            } else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 9 : if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               marker = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  marker = OFF;
               fprintf(stdout,"   Options : marker          = %s\n",value);
            } else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 10: if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               markerchange = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  markerchange = OFF;
               fprintf(stdout,"   Options : markerchange    = %s\n",value);
            } else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 11: scale = atof(value); 
            if (scale < 0.1 || scale > 1) scale = 1.0;
            fprintf(stdout,"   Options : scale           = %f\n",scale);
            break;
   case 12: xticks = atoi(value); 
            if (xticks <= 0 || xticks > 20) xticks = 4;
            fprintf(stdout,"   Options : xticks          = %d\n",xticks);
            autorange =  OFF;
            break;
   case 13: yticks = atoi(value); 
            if (yticks <= 0 || yticks > 20) yticks = 4;
            fprintf(stdout,"   Options : yticks          = %d\n",yticks);
            autorange =  OFF;
            break;
   case 14: sleeptime = atoi(value); 
            if (sleeptime <= 0) sleeptime = 4;
            fprintf(stdout,"   Options : sleeptime       = %d\n",sleeptime);
            break;
   case 15: strcpy(template, value); 
            fprintf(stdout,"   Options : Template File   = \"%s\"\n",template);
            if ((ftp = fopen(template, "r")) == NULL) {
               fprintf(stdout,"   cat: can't open %s\n", template);
               fprintf(stdout,"        Default Plot types will be used\n");
            } else {
               process_template(ftp);
               if (plottypes <=0) {
                  plottypes = 17;
                  fprintf(stdout,"   Warning : Read Error\n");
                  fprintf(stdout,"      Default Plot types will be used\n");
               } else {
                  line         = ON;
                  marker       = ON;
                  linechange   = ON;
                  markerchange = ON;
               }
            }
            break;
   case 16: if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               xlog = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  xlog = OFF;
               fprintf(stdout,"   Options : xlog            = %s\n",value);
            } else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 17: if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               ylog = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  ylog = OFF;
               fprintf(stdout,"   Options : ylog            = %s\n",value);
            } else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 18: if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               landscape = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  landscape = OFF;
               fprintf(stdout,"   Options : landscape       = %s\n",value);
            } else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 19: if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               clip = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  clip = OFF;
               fprintf(stdout,"   Options : clip            = %s\n",value);
            } else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 20: sprintf(printer,"-P%s",value);
            fprintf(stdout,"   Commands: Printer         = %s\n",printer);
            break;
   case 21: if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               noplot = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  noplot = OFF;
               fprintf(stdout,"   Options : noplot          = %s\n",value);
            } else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 22: if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               autorange = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  autorange = OFF;
               fprintf(stdout,"   Options : autorange       = %s\n",value);
            } else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   default: break;
   }
}

/* read in plot types and marker types */
process_template(ftp)
FILE *ftp;
{
   extern int linetype[MAXTYPE],markertype[MAXTYPE],plottypes;
   extern char linelabel[MAXTYPE][MAXCHAR];
   int    len,i,nwds,nnum,num[MAXTYPE];
   char   line[MAXCHAR];
   char   word[100][MAXCHAR];

   plottypes = 0;
   while (len=getline(ftp,line, MAXCHAR) > 0) {
      nnum = 0;
      if ((nwds=getwords(line,len,word)) >= 0) {

         /* collect all the numbers in the line */
         for (i=0; i<nwds; i++) {
            if (word_is_number(word[i]) && nnum < MAXTYPE) 
               num[nnum++] = atoi(word[i]);
         }

         /* use only the first 2 numbers in the line */
         if (nnum > 0) linetype[plottypes] = num[0];
         else          linetype[plottypes] = 1;
         if (nnum > 1) markertype[plottypes] = num[1];
         else          markertype[plottypes] = 0;

         /* assign linelabels */
         strcpy(linelabel[plottypes],"");
         for (i=0; i<nwds; i++) {
            if ( ( (strcmp(word[i],"line_label")==0) ||
                   (strcmp(word[i],"label"     )==0) ||
                   (strcmp(word[i],"linelabel" )==0) ) && (i < nwds-1) )
            strcpy(linelabel[plottypes],word[i+1]);
         }
         
         /* increment plottype */
         plottypes++;
      }
   }
   for (i=0; i<plottypes; i++)
      fprintf(stdout,
      "   Plot #%3d   Linetype= %3d  Markertype= %3d   Linelabel= \"%s\"\n",
      i,linetype[i],markertype[i],linelabel[i]);
}

/* find out if a word is a number */
word_is_number(value)
char *value;
{
   int  chartoint();
   int  i,num,wdnum=TRUE;
   for (i=0; i<MAXCHAR && value[i]!='\0' && wdnum; i++) 
      if (num=chartoint(value[i])<0) wdnum=FALSE;
   return(wdnum);
}

/* Convert a line of characters into numbers; Not in use */
convertline(value) 
char *value;
{
   extern int linetype[MAXTYPE];
   int i,j;

   for (i=0; i<MAXCHAR && value[i]!='\0'; i++) 
      linetype[i] = chartoint(value[i]);
   for (j=i; j<MAXTYPE; j++)
      linetype[j] = linetype[j % i];
}

/* Convert a character into a number */
chartoint(ch) 
char ch;
{ 
   int num;

   switch (ch) {
   case '0' : num = 0; break;
   case '1' : num = 1; break;
   case '2' : num = 2; break;
   case '3' : num = 3; break;
   case '4' : num = 4; break;
   case '5' : num = 5; break;
   case '6' : num = 6; break;
   case '7' : num = 7; break;
   case '8' : num = 8; break;
   case '9' : num = 9; break;
   default  : num = -1; break;
   /* fprintf(stderr,"Warning : Nonnumeric character %c in string",ch);*/
   }
   return(num);
}

/* get line into s */
getline(op,s,lim)  
FILE *op;
char s[];
int lim;
{
    int c,i,j;

    /* read the line until termination marks ';' or '#' */
    for (i=0; i<lim-1 && (c=getc(op))!=EOF && c!='\n'&&c!='#'&& c!=';' ; ++i) 
       s[i] = c;
    if (i==lim-1 || c==';' ||c=='#' || c=='\n') s[i++] = '\n'; 
    if (c==';'||c=='#')
       for (j=0; (c=getc(op))!=EOF && c!='\n'; ++j);
    s[i] = '\0';

    return(i);
}

/* Get the first 2 words in a line */
getwords(s,length,word) 
char s[];
int length;
char word[100][MAXCHAR];
{
   int i,nc,nw,inword,collectword;
   char c, cprev;

   nc = nw = 0;
   inword = NO;
   collectword = NO;

   if (length==1 && s[0] == '\n') return(nw);
   for (i=0; s[i] != '\0'; i++) {
      c = s[i];
      if (c == ' ' || c=='\n' || c == '\t' || c=='=') {
         if (inword == YES && (collectword==NO || c=='\n') ) {
            word[nw++][nc++] = '\0';
            inword = NO;
            nc = 0;
         } else if (collectword == YES)
            word[nw][nc++] = c;
      } else if (c == '\'' || c == '"') {
         if (collectword == NO) {
            collectword = YES; 
            cprev = c;
         } else if (cprev ==  c) {
            collectword = NO; 
            word[nw++][nc++] = '\0';
            inword = NO;
            nc = 0;
         } else {
           word[nw][nc++] = c;
           if (inword == NO) inword = YES;
         }
      } else {
         word[nw][nc++] = c;
         if (inword == NO) inword = YES;
      }
   }

   return(nw);
}

/* Convert a word into a number */
/* Not in use - currently use the library function atof() */
double word_to_number(word)
char word[];
{
  int i;
  int decimal_flag;
  int exponent_flag;
  int decimal_count;
  int new_term;
  double number,sign,exponent,exp_sign;

  sign = 1.;
  exp_sign = 1.;
  decimal_flag = OFF;
  exponent_flag = OFF;
  decimal_count = 0;
  number = 0.;
  exponent = 0.;

  for (i = 0; word[i] != '\0'; i++) {
     if (word[i] == '-' && exponent_flag == OFF)
        sign = -1.;
     else if (word[i] != '+') {
        if      (word[i] == '.') decimal_flag = ON;
        else if (word[i] == 'e') exponent_flag = ON;
        else {
           new_term = word[i] - '0';
           if (exponent_flag) {
              if (word[i] == '-')
                 exp_sign = -1.;
              else 
                 exponent = exponent * 10. + (double) new_term;
           } else {
              number = number * 10. + (double) new_term;
              if (decimal_flag) decimal_count++;
           }
        }
     }
  }
  for (; decimal_count > 0; decimal_count--)
    number /= 10.; 
  
  number = number * sign * pow((double)10.,(exp_sign * exponent));

  return number;
}

